/*!
 * module-loader.js v0.0.8
 * (c) 2014-2020 stwilson
 * Released under the MIT License.
 */
import { Container, injectable, inject, METADATA_KEY, decorate, multiInject } from 'inversify';
export { inject, injectable } from 'inversify';
import 'reflect-metadata';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
}

var IocManager = /** @class */ (function () {
    function IocManager() {
        this.denpendcyRegisters = [];
        this.diConainter = new Container();
    }
    IocManager.prototype.addDenpendcyRegistrar = function (registrar) {
        this.denpendcyRegisters.push(registrar);
    };
    IocManager.prototype.registerModuleByConvention = function (moduleContexts) {
        var e_1, _a;
        var registerCTX = new RegistrationContext(moduleContexts, this);
        try {
            for (var _b = __values(this.denpendcyRegisters), _c = _b.next(); !_c.done; _c = _b.next()) {
                var register = _c.value;
                register.register(registerCTX);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    IocManager.prototype.register = function (ContainerDelegate) {
        if (ContainerDelegate !== undefined)
            ContainerDelegate(this.diConainter);
    };
    IocManager.prototype.get = function (serviceIdentifier) {
        return this.diConainter.get(serviceIdentifier);
    };
    IocManager.prototype.getAll = function (serviceIdentifier) {
        return this.diConainter.getAll(serviceIdentifier);
    };
    IocManager.prototype.isRegistered = function (serviceIdentifier) {
        return this.diConainter.isBound(serviceIdentifier);
    };
    IocManager.prototype.unbindAll = function () {
        this.diConainter.unbindAll();
    };
    IocManager.prototype.getContainer = function () {
        return this.diConainter;
    };
    return IocManager;
}());
var RegistrationContext = /** @class */ (function () {
    function RegistrationContext(moduleContexts, iocManager) {
        this.iocManger = iocManager;
        this.moduleContexts = moduleContexts;
    }
    return RegistrationContext;
}());

var BootstrapperOptions = /** @class */ (function () {
    function BootstrapperOptions() {
        this.iocManager = new IocManager();
    }
    return BootstrapperOptions;
}());

var Types = {
    IBlocksShell: Symbol.for("IBlocksShell"),
    IRouteProvider: Symbol.for("IRouteProvider"),
    ITemplateProvider: Symbol.for("ITemplateProvider"),
    IBootstrapper: Symbol.for("IBootstrapper"),
    IManifestProvider: Symbol.for("IManifestProvider"),
    IResourceManager: Symbol.for("IResourceManager"),
    IRouteManager: Symbol.for("IRouteManager"),
    BlocksModule: Symbol.for("BlocksModule")
};

// let _win: any = window;
// let globalIocManager: IocManager = _win["globalIocManager"] || new IocManager();
// _win["globalIocManager"] = globalIocManager;
var IDependency = /** @class */ (function () {
    function IDependency() {
    }
    IDependency = __decorate([
        injectable()
    ], IDependency);
    return IDependency;
}());
var IBlocksShell = /** @class */ (function () {
    function IBlocksShell() {
        this.types = [];
        this.typeMapModuleName = new Map();
        this.moduleMapTypes = new Map();
    }
    IBlocksShell.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error("initialize is not implemented. ");
            });
        });
    };
    Object.defineProperty(IBlocksShell.prototype, "BlocksModules", {
        get: function () {
            throw new Error("initialize is not implemented. ");
        },
        enumerable: true,
        configurable: true
    });
    return IBlocksShell;
}());
var IBootstrapper = /** @class */ (function () {
    function IBootstrapper() {
    }
    Object.defineProperty(IBootstrapper.prototype, "PlugInSources", {
        get: function () {
            throw new Error("plugInSources is not implemented. ");
        },
        enumerable: true,
        configurable: true
    });
    IBootstrapper.prototype.initialize = function () {
        throw new Error("initialize is not implemented. ");
    };
    IBootstrapper.prototype.dispose = function () {
        throw new Error("dispose is not implemented. ");
    };
    return IBootstrapper;
}());
var startupModuleDefine = /** @class */ (function (_super) {
    __extends(startupModuleDefine, _super);
    function startupModuleDefine() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.moduleName = "";
        return _this;
    }
    startupModuleDefine.prototype.getProviders = function () {
        throw new Error("getProviders is not implemented.");
    };
    return startupModuleDefine;
}(IDependency));
var IShell = /** @class */ (function (_super) {
    __extends(IShell, _super);
    function IShell() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pluginSource = [];
        _this.types = [];
        _this.moduleMapTypes = new Map();
        _this.typeMapModuleName = new Map();
        return _this;
    }
    IShell.prototype.initialize = function () {
    };
    return IShell;
}(IDependency));
var BlocksModule = /** @class */ (function (_super) {
    __extends(BlocksModule, _super);
    function BlocksModule() {
        var _this = _super.call(this) || this;
        //TODO Need to SortModule??
        _this.order = 10;
        _this.providers = function () { return []; };
        _this.moduleName = "default";
        return _this;
    }
    BlocksModule.prototype.preInitialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    BlocksModule.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    BlocksModule.prototype.getProviders = function () {
        return this.providers();
    };
    BlocksModule.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    __decorate([
        inject(IocManager),
        __metadata("design:type", IocManager)
    ], BlocksModule.prototype, "iocManager", void 0);
    return BlocksModule;
}(IDependency));

var IRouteProvider = /** @class */ (function (_super) {
    __extends(IRouteProvider, _super);
    function IRouteProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IRouteProvider.prototype.getRoutes = function () {
        throw new Error("getRoutes is not implemented.");
    };
    return IRouteProvider;
}(IDependency));
var ITemplateProvider = /** @class */ (function (_super) {
    __extends(ITemplateProvider, _super);
    function ITemplateProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ITemplateProvider.prototype.getTemplate = function () {
        throw new Error("getTemplate is not implemented.");
    };
    return ITemplateProvider;
}(IDependency));
var RouteResult = /** @class */ (function () {
    function RouteResult() {
        this.layout = "";
        this.path = "";
        this.children = [];
    }
    return RouteResult;
}());
var TemplateResult = /** @class */ (function () {
    function TemplateResult() {
    }
    return TemplateResult;
}());
var getUniqueKey = function (moduleName, uniqueKey) { return uniqueKey + "_" + moduleName; };

var IManifestProvider = /** @class */ (function (_super) {
    __extends(IManifestProvider, _super);
    function IManifestProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IManifestProvider.prototype.buildManifests = function (builder) {
        throw new Error("buildManifests is not implemented.");
    };
    return IManifestProvider;
}(IDependency));
var ResourceManifest = /** @class */ (function () {
    function ResourceManifest() {
        this.resources = [];
    }
    ResourceManifest.prototype.defineResource = function (resourceType, resourceName) {
        var manifest = new ResourceDefinition(resourceType, resourceName);
        this.resources.push(manifest);
        return manifest;
    };
    return ResourceManifest;
}());
var ResourceDefinition = /** @class */ (function () {
    function ResourceDefinition(resourceType, resourceName) {
        this.resourceName = resourceName;
        this.resourceType = resourceType;
    }
    ResourceDefinition.prototype.add = function (resource) {
        this.resource = resource;
    };
    return ResourceDefinition;
}());
var ResourceManifestBuilder = /** @class */ (function () {
    function ResourceManifestBuilder() {
        this.resourceManifests = [];
    }
    ResourceManifestBuilder.prototype.add = function () {
        var manifest = new ResourceManifest();
        this.resourceManifests.push(manifest);
        return manifest;
    };
    return ResourceManifestBuilder;
}());
var getResourceKey = function (resourceType, resourceName) {
    return resourceType + "-" + resourceName;
};

var decorateIfNoExist = function (decorator, target, parameterIndex) {
    if (Reflect.hasOwnMetadata(METADATA_KEY.PARAM_TYPES, target))
        return;
    return decorate(decorator, target, parameterIndex);
};

var typeCheckExpression = [];

var RouteManager = /** @class */ (function () {
    function RouteManager(IocManager) {
        this.iocManager = IocManager;
    }
    RouteManager.prototype.getUniquePath = function () {
        var e_1, _a, e_2, _b, e_3, _c;
        var routes = this.getRoute();
        var routePaths = [];
        try {
            for (var routes_1 = __values(routes), routes_1_1 = routes_1.next(); !routes_1_1.done; routes_1_1 = routes_1.next()) {
                var route = routes_1_1.value;
                if (!route.children) {
                    routePaths.push(Object.assign(true, {}, route, { meta: { uniqueKey: route.uniqueKey } }));
                    continue;
                }
                try {
                    for (var _d = (e_2 = void 0, __values(route.children)), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var routeChild = _e.value;
                        if (!routeChild.children) {
                            routePaths.push(Object.assign(true, routeChild, { path: route.path + "/" + routeChild.path, meta: { uniqueKey: routeChild.uniqueKey } }));
                            continue;
                        }
                        try {
                            for (var _f = (e_3 = void 0, __values(routeChild.children)), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var routeChildTemp = _g.value;
                                if (!routeChildTemp.children) {
                                    routePaths.push(Object.assign(true, routeChild, { path: route.path + "/" + routeChild.path + "/" + routeChildTemp.path, meta: { uniqueKey: routeChildTemp.uniqueKey } }));
                                    continue;
                                }
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (routes_1_1 && !routes_1_1.done && (_a = routes_1.return)) _a.call(routes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return routePaths;
    };
    RouteManager.prototype.getRoute = function () {
        var e_4, _a, e_5, _b;
        var routeObj = [];
        var templateProviders = this.iocManager.isRegistered(Types.ITemplateProvider) ? this.iocManager.getAll(Types.ITemplateProvider) : [];
        if (!this.iocManager.isRegistered(Types.IRouteProvider))
            return routeObj;
        try {
            for (var _c = __values(this.iocManager.getAll(Types.IRouteProvider)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var routeProvider = _d.value;
                var moduleName = this.iocManager.get(Types.IBlocksShell)
                    .typeMapModuleName.get(routeProvider.constructor);
                var routes = routeProvider.getRoutes();
                if (!routes || !Array.isArray(routes))
                    continue;
                var layoutRouteChilds = {};
                var _loop_1 = function (route) {
                    var e_6, _a;
                    route.path = moduleName + "/" + route.path;
                    if (route.uniqueKey) {
                        route.uniqueKey = RouteManager.getUniqueKey(moduleName, route.uniqueKey); //  route.uniqueKey + "_" + moduleName;
                        route.meta = Object.assign(true, route.meta, { uniqueKey: route.uniqueKey });
                    }
                    if (route.layout) {
                        layoutRouteChilds[route.layout] = layoutRouteChilds[route.layout] ? layoutRouteChilds[route.layout] : new RouteResult();
                        var tempRoute = layoutRouteChilds[route.layout];
                        try {
                            for (var templateProviders_1 = (e_6 = void 0, __values(templateProviders)), templateProviders_1_1 = templateProviders_1.next(); !templateProviders_1_1.done; templateProviders_1_1 = templateProviders_1.next()) {
                                var templateProvider = templateProviders_1_1.value;
                                var template = templateProvider.getTemplate().find(function (t) { return t.name === route.layout; });
                                if (template) {
                                    tempRoute = Object.assign(tempRoute, template);
                                    route.name = route.name ? route.name : route.uniqueKey;
                                    tempRoute.children.push(route);
                                    break;
                                }
                            }
                        }
                        catch (e_6_1) { e_6 = { error: e_6_1 }; }
                        finally {
                            try {
                                if (templateProviders_1_1 && !templateProviders_1_1.done && (_a = templateProviders_1.return)) _a.call(templateProviders_1);
                            }
                            finally { if (e_6) throw e_6.error; }
                        }
                        if (tempRoute.children.length < 1)
                            routeObj.push(route);
                        return "continue";
                    }
                    if (!route.path.startsWith("/"))
                        route.path = "/" + route.path;
                    routeObj.push(route);
                };
                try {
                    for (var routes_2 = (e_5 = void 0, __values(routes)), routes_2_1 = routes_2.next(); !routes_2_1.done; routes_2_1 = routes_2.next()) {
                        var route = routes_2_1.value;
                        _loop_1(route);
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (routes_2_1 && !routes_2_1.done && (_b = routes_2.return)) _b.call(routes_2);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
                for (var layoutRouteKey in layoutRouteChilds) {
                    if (layoutRouteChilds.hasOwnProperty(layoutRouteKey)) {
                        var tempRoute = layoutRouteChilds[layoutRouteKey];
                        routeObj.push(Object.assign({}, tempRoute));
                    }
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return routeObj;
    };
    RouteManager.getUniqueKey = function (moduleName, uniqueKey) { return uniqueKey + "_" + moduleName; };
    RouteManager = __decorate([
        __param(0, inject(IocManager)),
        __metadata("design:paramtypes", [IocManager])
    ], RouteManager);
    return RouteManager;
}());

var RouteStartupModule = /** @class */ (function (_super) {
    __extends(RouteStartupModule, _super);
    function RouteStartupModule() {
        var _this = _super.call(this) || this;
        _this.moduleName = "RouteStartupModule";
        return _this;
    }
    RouteStartupModule.prototype.preInitialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var iocManagerTmp;
            return __generator(this, function (_a) {
                if (!this.shell)
                    throw new Error("Shell is null or empty.");
                if (!this.iocManager)
                    throw new Error("iocManager is null or empty.");
                iocManagerTmp = this.iocManager;
                iocManagerTmp.register(function (c) {
                    //hahhahaahahah
                    debugger;
                    c.bind(Types.IRouteManager).to(RouteManager).inSingletonScope();
                    decorateIfNoExist(injectable(), RouteManager);
                });
                this.shell.moduleMapTypes.forEach(function (typeMap, ModuleType) {
                    typeMap.forEach(function (type, index) {
                        if (type.prototype instanceof IRouteProvider) {
                            iocManagerTmp.register(function (c) {
                                c.bind(Types.IRouteProvider).to(type).inTransientScope();
                            });
                        }
                        if (type.prototype instanceof ITemplateProvider) {
                            iocManagerTmp.register(function (c) {
                                c.bind(Types.ITemplateProvider).to(type).inTransientScope();
                            });
                        }
                    });
                });
                return [2 /*return*/];
            });
        });
    };
    __decorate([
        inject(Types.IBlocksShell),
        __metadata("design:type", IShell)
    ], RouteStartupModule.prototype, "shell", void 0);
    return RouteStartupModule;
}(BlocksModule));

var resourceManager = /** @class */ (function () {
    function resourceManager(blocksShell, manifestProviders) {
        this.resources = new Map();
        this.blocksShell = blocksShell;
        this.manifestProviders = manifestProviders;
    }
    resourceManager.prototype.getResources = function () {
        if (this.resources.size === 0)
            this.buildResource();
        return this.resources;
    };
    resourceManager.prototype.getResource = function (moduleName, resourceType, resourceName) {
        var moduleResource = this.getResources().get(moduleName);
        if (!moduleResource || !moduleResource.has(getResourceKey(resourceType, resourceName))) {
            throw new Error("Can not found resourceType:" + resourceType + ", resourceName:" + resourceName + " in resources.");
        }
        return moduleResource.get(getResourceKey(resourceType, resourceName));
    };
    resourceManager.prototype.buildResource = function () {
        var e_1, _a, e_2, _b, e_3, _c;
        try {
            for (var _d = __values(this.manifestProviders), _e = _d.next(); !_e.done; _e = _d.next()) {
                var manifestProvider = _e.value;
                var builder = new ResourceManifestBuilder();
                manifestProvider.buildManifests(builder);
                var moduleName = this.blocksShell.typeMapModuleName.get(manifestProvider.constructor);
                if (moduleName === undefined)
                    throw new Error(manifestProvider.constructor + " can not found moduleName.");
                if (!this.resources.has(moduleName))
                    this.resources.set(moduleName, new Map());
                try {
                    for (var _f = (e_2 = void 0, __values(builder.resourceManifests)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var manifest = _g.value;
                        try {
                            for (var _h = (e_3 = void 0, __values(manifest.resources)), _j = _h.next(); !_j.done; _j = _h.next()) {
                                var resource = _j.value;
                                var resourceNameMap = this.resources.get(moduleName);
                                if (resourceNameMap)
                                    resourceNameMap.set(getResourceKey(resource.resourceType, resource.resourceName), resource);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (_j && !_j.done && (_c = _h.return)) _c.call(_h);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    resourceManager = __decorate([
        __param(0, inject(Types.IBlocksShell)), __param(1, multiInject(Types.IManifestProvider)),
        __metadata("design:paramtypes", [IBlocksShell, Array])
    ], resourceManager);
    return resourceManager;
}());

var manifestStartupModule = /** @class */ (function (_super) {
    __extends(manifestStartupModule, _super);
    function manifestStartupModule() {
        var _this = _super.call(this) || this;
        _this.moduleName = "ManifestStartupModule";
        return _this;
    }
    manifestStartupModule.prototype.preInitialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var iocManagerTmp;
            return __generator(this, function (_a) {
                if (!this.shell)
                    throw new Error("Shell is null or empty.");
                if (!this.iocManager)
                    throw new Error("iocManager is null or empty.");
                iocManagerTmp = this.iocManager;
                iocManagerTmp.register(function (c) {
                    c.bind(Types.IResourceManager).to(resourceManager).inSingletonScope();
                    decorateIfNoExist(injectable(), resourceManager);
                });
                this.shell.moduleMapTypes.forEach(function (typeMap, ModuleType) {
                    typeMap.forEach(function (type, index) {
                        if (type.prototype instanceof IManifestProvider) {
                            iocManagerTmp.register(function (c) {
                                c.bind(Types.IManifestProvider).to(type).inTransientScope();
                            });
                        }
                    });
                });
                return [2 /*return*/];
            });
        });
    };
    __decorate([
        inject(Types.IBlocksShell),
        __metadata("design:type", IShell)
    ], manifestStartupModule.prototype, "shell", void 0);
    return manifestStartupModule;
}(BlocksModule));

var BlocksShell = /** @class */ (function () {
    function BlocksShell(iocManager) {
        this.pluginSource = [];
        this.iocManager = iocManager;
        this.types = [];
        this.typeMapModuleName = new Map();
        this.moduleMapTypes = new Map();
        this.typeMapFileName = new Map();
        this.blocksModules = [];
    }
    Object.defineProperty(BlocksShell.prototype, "BlocksModules", {
        get: function () {
            return this.blocksModules;
        },
        enumerable: true,
        configurable: true
    });
    BlocksShell.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, filesArray, startupModules, temp, startupModules_1, startupModules_1_1, module_1, startupModules_2, startupModules_2_1, startupModule, moduleType, moduleType_1, moduleType_1_1, type, orders, orderGroup, orderGroup_1, orderGroup_1_1, orderModules, e_1_1, orderGroup_2, orderGroup_2_1, orderModules, e_2_1;
            var e_3, _c, e_4, _d, e_5, _e, e_6, _f, e_1, _g, e_2, _h;
            var _this = this;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        try {
                            for (_a = __values(this.getTypeFromFiles()), _b = _a.next(); !_b.done; _b = _a.next()) {
                                filesArray = _b.value;
                                this.moduleAndDependencyLoader(filesArray);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        this.autoRegisterModule(RouteStartupModule);
                        this.autoRegisterModule(manifestStartupModule);
                        startupModules = this.iocManager.getAll(Types.BlocksModule);
                        this.blocksModules = startupModules;
                        temp = new Map();
                        try {
                            for (startupModules_1 = __values(startupModules), startupModules_1_1 = startupModules_1.next(); !startupModules_1_1.done; startupModules_1_1 = startupModules_1.next()) {
                                module_1 = startupModules_1_1.value;
                                if (temp.has(module_1.moduleName))
                                    throw new Error("ModuleName " + module_1.moduleName + " is registered double.");
                                temp.set(module_1.moduleName, []);
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (startupModules_1_1 && !startupModules_1_1.done && (_d = startupModules_1.return)) _d.call(startupModules_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        // for (let module of startupModules) {
                        //     if (this.ModuleMapTypes.has(module.ModuleName))
                        //         throw new Error(`ModuleName {ModuleName} is registered double.`)
                        //     this.ModuleMapTypes.set(module.ModuleName, []);
                        // }
                        this.moduleMapTypes.forEach(function (moduleMapSet, moduleTypeKey) {
                            var moduleType = _this.typeMapFileName.get(moduleTypeKey);
                            if (!moduleType)
                                return;
                            var moduleFilePrefix = moduleType[1];
                            moduleFilePrefix = moduleFilePrefix.substring(0, moduleFilePrefix.lastIndexOf('/') + 1);
                            _this.typeMapFileName.forEach(function (value, typeMapKey) {
                                if (value[1].startsWith(moduleFilePrefix)) {
                                    moduleMapSet.push(typeMapKey);
                                }
                            });
                        });
                        try {
                            for (startupModules_2 = __values(startupModules), startupModules_2_1 = startupModules_2.next(); !startupModules_2_1.done; startupModules_2_1 = startupModules_2.next()) {
                                startupModule = startupModules_2_1.value;
                                if (!this.moduleMapTypes.has(startupModule.constructor))
                                    continue;
                                moduleType = this.moduleMapTypes.get(startupModule.constructor);
                                if (!moduleType)
                                    continue;
                                try {
                                    for (moduleType_1 = (e_6 = void 0, __values(moduleType)), moduleType_1_1 = moduleType_1.next(); !moduleType_1_1.done; moduleType_1_1 = moduleType_1.next()) {
                                        type = moduleType_1_1.value;
                                        this.typeMapModuleName.set(type, startupModule.moduleName);
                                    }
                                }
                                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                                finally {
                                    try {
                                        if (moduleType_1_1 && !moduleType_1_1.done && (_f = moduleType_1.return)) _f.call(moduleType_1);
                                    }
                                    finally { if (e_6) throw e_6.error; }
                                }
                            }
                        }
                        catch (e_5_1) { e_5 = { error: e_5_1 }; }
                        finally {
                            try {
                                if (startupModules_2_1 && !startupModules_2_1.done && (_e = startupModules_2.return)) _e.call(startupModules_2);
                            }
                            finally { if (e_5) throw e_5.error; }
                        }
                        orders = startupModules.map(function (m) { return m.order; }).reduce(function (cur, next) {
                            if (!cur.includes(next))
                                cur.push(next);
                            return cur;
                        }, new Array()).sort(function (a, b) { return a - b; });
                        orderGroup = orders.reduce(function (cur, next) {
                            cur.push(startupModules.filter(function (m) { return m.order === next; }));
                            return cur;
                        }, new Array());
                        _j.label = 1;
                    case 1:
                        _j.trys.push([1, 6, 7, 8]);
                        orderGroup_1 = __values(orderGroup), orderGroup_1_1 = orderGroup_1.next();
                        _j.label = 2;
                    case 2:
                        if (!!orderGroup_1_1.done) return [3 /*break*/, 5];
                        orderModules = orderGroup_1_1.value;
                        return [4 /*yield*/, Promise.all(orderModules.map(function (m) { return m.preInitialize(); }))];
                    case 3:
                        _j.sent();
                        _j.label = 4;
                    case 4:
                        orderGroup_1_1 = orderGroup_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _j.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (orderGroup_1_1 && !orderGroup_1_1.done && (_g = orderGroup_1.return)) _g.call(orderGroup_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 8:
                        _j.trys.push([8, 13, 14, 15]);
                        orderGroup_2 = __values(orderGroup), orderGroup_2_1 = orderGroup_2.next();
                        _j.label = 9;
                    case 9:
                        if (!!orderGroup_2_1.done) return [3 /*break*/, 12];
                        orderModules = orderGroup_2_1.value;
                        return [4 /*yield*/, Promise.all(orderModules.map(function (m) { return m.initialize(); }))];
                    case 10:
                        _j.sent();
                        _j.label = 11;
                    case 11:
                        orderGroup_2_1 = orderGroup_2.next();
                        return [3 /*break*/, 9];
                    case 12: return [3 /*break*/, 15];
                    case 13:
                        e_2_1 = _j.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 15];
                    case 14:
                        try {
                            if (orderGroup_2_1 && !orderGroup_2_1.done && (_h = orderGroup_2.return)) _h.call(orderGroup_2);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 15: return [2 /*return*/];
                }
            });
        });
    };
    BlocksShell.prototype.moduleAndDependencyLoader = function (filesArray) {
        var e_7, _a;
        var _this = this;
        var registerAction = function (fileKey) {
            var e_8, _a, e_9, _b;
            var exportTypes = filesArray(fileKey);
            try {
                for (var _c = __values(Object.keys(exportTypes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var objKey = _d.value;
                    var exportType = exportTypes[objKey];
                    if (!exportType)
                        continue;
                    var isModule = _this.autoRegisterModule(exportType);
                    if (isModule)
                        _this.moduleMapTypes.set(exportType, []);
                    if (exportType.prototype instanceof IDependency) {
                        _this.typeMapFileName.set(exportType, [isModule, fileKey]);
                        _this.types.push(exportTypes[objKey]);
                    }
                    try {
                        for (var typeCheckExpression_1 = (e_9 = void 0, __values(typeCheckExpression)), typeCheckExpression_1_1 = typeCheckExpression_1.next(); !typeCheckExpression_1_1.done; typeCheckExpression_1_1 = typeCheckExpression_1.next()) {
                            var checkExppression = typeCheckExpression_1_1.value;
                            var type = checkExppression(exportType);
                            if (type) {
                                _this.typeMapFileName.set(type, [isModule, fileKey]);
                                _this.types.push(type);
                                break;
                            }
                        }
                    }
                    catch (e_9_1) { e_9 = { error: e_9_1 }; }
                    finally {
                        try {
                            if (typeCheckExpression_1_1 && !typeCheckExpression_1_1.done && (_b = typeCheckExpression_1.return)) _b.call(typeCheckExpression_1);
                        }
                        finally { if (e_9) throw e_9.error; }
                    }
                    // if (exportType.prototype instanceof Controller && exportType.options.type) {
                    //     this.typeMapFileName.set(exportType.options.type, [isModule, fileKey]);
                    //     this.types.push(exportType.options.type);
                    // }
                    // if(fileKey.lastIndexOf(".bl.ts"))
                    // {
                    //     debugger
                    //     decorate(Component(), exportType);
                    // }
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_8) throw e_8.error; }
            }
        };
        try {
            for (var _b = __values(filesArray.keys()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var fileKey = _c.value;
                registerAction(fileKey);
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_7) throw e_7.error; }
        }
    };
    BlocksShell.prototype.autoRegisterModule = function (type) {
        if (type.prototype instanceof BlocksModule) {
            this.iocManager.register(function (c) {
                c.bind(Types.BlocksModule).to(type).inTransientScope();
                decorateIfNoExist(injectable(), type);
            });
            return true;
        }
        return false;
    };
    BlocksShell.prototype.getTypeFromFiles = function () {
        return this.pluginSource.values();
    };
    BlocksShell = __decorate([
        __param(0, inject(IocManager)),
        __metadata("design:paramtypes", [IocManager])
    ], BlocksShell);
    return BlocksShell;
}());

var BlocksBoostrapper = /** @class */ (function (_super) {
    __extends(BlocksBoostrapper, _super);
    function BlocksBoostrapper(startModule, optionsFunc) {
        var _this = _super.call(this) || this;
        var bootstarpperOptions = new BootstrapperOptions();
        if (optionsFunc !== undefined) {
            optionsFunc(bootstarpperOptions);
        }
        _this.iocManager = bootstarpperOptions.iocManager;
        _this.startModule = startModule;
        _this.plugInSources = [];
        return _this;
        // this.RouteHelper = new RouteHelperCls(this.iocManager);
    }
    Object.defineProperty(BlocksBoostrapper.prototype, "RouteHelper", {
        get: function () {
            return this.iocManager.get(Types.IRouteManager);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BlocksBoostrapper.prototype, "PlugInSources", {
        get: function () {
            return this.plugInSources;
        },
        enumerable: true,
        configurable: true
    });
    BlocksBoostrapper.create = function (startModule, optionsFunc) {
        return new BlocksBoostrapper(startModule, optionsFunc);
    };
    BlocksBoostrapper.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var shell;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //Logger
                        this.registerShell();
                        shell = this.iocManager.get(Types.IBlocksShell);
                        shell.pluginSource = this.plugInSources;
                        return [4 /*yield*/, shell.initialize()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BlocksBoostrapper.prototype.registerShell = function () {
        var _this = this;
        this.iocManager.register(function (c) {
            c.bind(IocManager).toConstantValue(_this.iocManager);
            c.bind(Types.IBlocksShell).to(BlocksShell).inSingletonScope();
            decorateIfNoExist(injectable(), IocManager);
            decorateIfNoExist(injectable(), BlocksShell);
        });
    };
    BlocksBoostrapper.prototype.dispose = function () {
        this.iocManager.unbindAll();
    };
    return BlocksBoostrapper;
}(IBootstrapper));

// const TYPES = {
//     BlocksModule: Symbol.for("BlocksModule"),
// };
decorate(injectable(), BlocksModule);
var Bootstrapper = BlocksBoostrapper.create(undefined, function (o) { return o.iocManager = new IocManager(); });

export { BlocksBoostrapper, BlocksModule, Bootstrapper, IBlocksShell, IBootstrapper, IDependency, IManifestProvider, IRouteProvider, IShell, ITemplateProvider, IocManager, ResourceManifestBuilder, RouteResult, TemplateResult, Types, decorateIfNoExist, getResourceKey, getUniqueKey, typeCheckExpression };
