import { Container, inject, injectable, multiInject } from "inversify";
import "reflect-metadata";
declare class IocManager {
    private denpendcyRegisters;
    private diConainter;
    constructor();
    addDenpendcyRegistrar(registrar: IDependencyRegister): void;
    registerModuleByConvention(moduleContexts: any): void;
    register(ContainerDelegate: (c: Container) => void): void;
    get<T>(serviceIdentifier: ServiceIdentifier<T>): T;
    getAll<T>(serviceIdentifier: ServiceIdentifier<T>): T[];
    isRegistered<T>(serviceIdentifier: ServiceIdentifier<T>): boolean;
    unbindAll(): void;
    getContainer(): Container;
}
declare type ServiceIdentifier<T> = (string | symbol | Newable<T> | Abstract<T>);
interface IDependencyRegister {
    register(RegistrationContexts: RegistrationContext): void;
}
interface Newable<T> {
    new (...args: any[]): T;
}
interface Abstract<T> {
    prototype: T;
}
declare class RegistrationContext {
    moduleContexts: any;
    iocManger: IocManager;
    constructor(moduleContexts: any, iocManager: IocManager);
}
export { IocManager, IDependencyRegister, RegistrationContext, inject, injectable, multiInject };
//# sourceMappingURL=iocManager.d.ts.map