import { IDependency } from "@/core/abstract";
declare class IManifestProvider extends IDependency {
    buildManifests(builder: ResourceManifestBuilder): void;
}
declare class ResourceManifest {
    resources: ResourceDefinition[];
    defineResource(resourceType: string, resourceName: string): ResourceDefinition;
}
declare class ResourceDefinition {
    resourceType: string;
    resourceName: string;
    resource: any;
    constructor(resourceType: string, resourceName: string);
    add(resource: any): void;
}
declare class ResourceManifestBuilder {
    resourceManifests: ResourceManifest[];
    add(): ResourceManifest;
}
interface IResourceManager {
    getResources(): Map<string, Map<string, ResourceDefinition>>;
    getResource(moduleName: string, resourceType: string, resourceName: string): ResourceDefinition | undefined;
    buildResource(): void;
}
declare let getResourceKey: (resourceType: string, resourceName: string) => string;
export { IManifestProvider, ResourceManifestBuilder, IResourceManager, ResourceDefinition, getResourceKey };
//# sourceMappingURL=abstract.d.ts.map