import { IDependency } from "@/core/abstract";
declare class IRouteProvider extends IDependency {
    getRoutes(): RouteResult[];
}
declare class ITemplateProvider extends IDependency {
    getTemplate(): TemplateResult[];
}
declare class RouteResult {
    layout: string;
    name?: string;
    path: string;
    component: any | string;
    components?: any[];
    children: RouteResult[];
    uniqueKey?: string;
    constructor();
    meta: any;
}
declare class TemplateResult {
    layout?: string;
    name?: string;
    path?: string;
    component: any | string;
    components?: any[];
    children?: RouteResult[];
}
interface IRouteManager {
    getUniquePath(): any[];
    getRoute(): any[];
}
interface layoutRouteChild {
    [key: string]: any;
}
declare let getUniqueKey: (moduleName: String | undefined, uniqueKey: String) => string;
export { IRouteProvider, ITemplateProvider, RouteResult, TemplateResult, IRouteManager, layoutRouteChild, getUniqueKey };
//# sourceMappingURL=abstract.d.ts.map